package com.njzscloud.supervisory.goods.service;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.IService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.njzscloud.common.mp.support.PageParam;
import com.njzscloud.common.mp.support.PageResult;
import com.njzscloud.supervisory.biz.pojo.entity.BizDriverEntity;
import com.njzscloud.supervisory.goods.mapper.GoodsCategoryMapper;
import com.njzscloud.supervisory.goods.pojo.entity.GoodsCategoryEntity;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 产品类型
 */
@Slf4j
@Service
public class GoodsCategoryService extends ServiceImpl<GoodsCategoryMapper, GoodsCategoryEntity> implements IService<GoodsCategoryEntity> {

    /**
     * 新增
     */
    public void add(GoodsCategoryEntity goodsCategoryEntity) {
        this.save(goodsCategoryEntity);
    }

    /**
     * 修改
     */
    public void modify(GoodsCategoryEntity goodsCategoryEntity) {
        this.updateById(goodsCategoryEntity);
    }

    /**
     * 删除
     */
    @Transactional(rollbackFor = Exception.class)
    public void del(List<Long> ids) {
        this.removeBatchByIds(ids);
    }

    /**
     * 详情
     */
    public GoodsCategoryEntity detail(Long id) {
        return this.getById(id);
    }

    /**
     * 分页查询
     */
    public PageResult<GoodsCategoryEntity> paging(PageParam pageParam, GoodsCategoryEntity goodsCategoryEntity) {
        return PageResult.of(this.page(pageParam.toPage(), Wrappers.<GoodsCategoryEntity>lambdaQuery()
                .like(StrUtil.isNotBlank(goodsCategoryEntity.getCategoryName()), GoodsCategoryEntity::getCategoryName,
                        goodsCategoryEntity.getCategoryName())));
    }

}
